# DataType.DataTypeWithRatioScale (ARX Developer Documentation)

org.deidentifier.arx

## Interface DataType.DataTypeWithRatioScale<T>

- Type Parameters:
    `T` -
  All Known Implementing Classes:
    DataType.ARXDate, DataType.ARXDecimal, DataType.ARXInteger
  Enclosing class:
    DataType<T>

      public static interface DataType.DataTypeWithRatioScale<T>

  An interface for data types with a ratio scale.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `T` | `add(T augend, T addend)`
    `int` | `compare(java.lang.String s1, java.lang.String s2)`
    `int` | `compare(T t1, T t2)`
    `java.lang.String` | `divide(java.lang.String dividend, java.lang.String divisor)`
    `T` | `divide(T dividend, T divisor)`
    `java.lang.String` | `format(T t)`
    `T` | `fromDouble(java.lang.Double d)` Converts a double into a value.
    `DataType.DataTypeDescription<T>` | `getDescription()`
    `T` | `getMaximum()`
    `T` | `getMinimum()`
    `boolean` | `isValid(java.lang.String s)`
    `java.lang.String` | `multiply(java.lang.String multiplicand, java.lang.String multiplicator)`
    `T` | `multiply(T multiplicand, double multiplicator)`
    `T` | `multiply(T multiplicand, int multiplicator)`
    `T` | `multiply(T multiplicand, T multiplicator)`
    `T` | `parse(java.lang.String s)`
    `double` | `ratio(T dividend, T divisor)`
    `T` | `subtract(T minuend, T subtrahend)`
    `java.lang.Double` | `toDouble(T t)` Converts a double into a value.

- - ### Method Detail

    - #### add

          T add(T augend,
              T addend)

      Parameters:
        `augend` -
        `addend` -
      Returns:

    - #### compare

          int compare(java.lang.String s1,
                    java.lang.String s2)
                      throws java.lang.NumberFormatException,
                             java.text.ParseException

      Parameters:
        `s1` -
        `s2` -
      Returns:
      Throws:
        `java.lang.NumberFormatException`
        `java.text.ParseException`

    - #### compare

          int compare(T t1,
                    T t2)

      Parameters:
        `t1` -
        `t2` -
      Returns:

    - #### divide

          java.lang.String divide(java.lang.String dividend,
                                java.lang.String divisor)

      Parameters:
        `dividend` -
        `divisor` -
      Returns:

    - #### divide

          T divide(T dividend,
                 T divisor)

      Parameters:
        `dividend` -
        `divisor` -
      Returns:

    - #### format

          java.lang.String format(T t)

      Parameters:
        `t` -
      Returns:

    - #### fromDouble

          T fromDouble(java.lang.Double d)

      Converts a double into a value.
      Parameters:
        `s` -
      Returns:

    - #### getDescription

          DataType.DataTypeDescription<T> getDescription()

      Returns:

    - #### getMaximum

          T getMaximum()

      Returns:

    - #### getMinimum

          T getMinimum()

      Returns:

    - #### isValid

          boolean isValid(java.lang.String s)

      Parameters:
        `s` -
      Returns:

    - #### multiply

          java.lang.String multiply(java.lang.String multiplicand,
                                  java.lang.String multiplicator)

      Parameters:
        `multiplicand` -
        `multiplicator` -
      Returns:

    - #### multiply

          T multiply(T multiplicand,
                   double multiplicator)

      Parameters:
        `multiplicand` -
        `multiplicator` -
      Returns:

    - #### multiply

          T multiply(T multiplicand,
                   int multiplicator)

      Parameters:
        `multiplicand` -
        `multiplicator` -
      Returns:

    - #### multiply

          T multiply(T multiplicand,
                   T multiplicator)

      Parameters:
        `multiplicand` -
        `multiplicator` -
      Returns:

    - #### parse

          T parse(java.lang.String s)

      Parameters:
        `s` -
      Returns:

    - #### ratio

          double ratio(T dividend,
                     T divisor)

      Parameters:
        `dividend` -
        `divisor` -
      Returns:

    - #### subtract

          T subtract(T minuend,
                   T subtrahend)

      Parameters:
        `minuend` -
        `subtrahend` -
      Returns:

    - #### toDouble

          java.lang.Double toDouble(T t)

      Converts a double into a value.
      Parameters:
        `s` -
      Returns: